package VolansCell;

import javax.microedition.io.*;
import javax.microedition.location.*;
import com.mot.iden.device.StatusManager;


/*
 * VolansCell - Version 6
 * (c) 2010 Chris VanHorn
 */
public class DataCollection extends Thread {

    // Current conditions
    public int count;                               // Itteration Count
    public int running;                             // Should we keep this thread running?
    public long lasttimestamp;                      // Timestamp of the last iterreration

    // Thread variables
    private String cellname;                        // Name of the phone
    private String cellpassword;                    // Phone password
    private MainThread themommy;                    // The parrent thread
    private String state;                           // Processing state
    private Criteria gpscriteria;                   // GPS Criteria
    private LocationProvider gpslocationprovider;   // GPS Location provider
    private Location gpslocation;                   // GPS current location
    private QualifiedCoordinates gpscoordinates;    // GPS Coordinates
    private String httpgetdata;                     // HTTP Get Data
    private String debug;                           // Debug data
    private HttpConnection httpconn;                // HTTP Connection
    private String url;                             // URL
    
    // *************************************************************************
    public DataCollection(MainThread temp, String tempname, String temppassword, String tempurl, int tempcount) {

        // Set some default values
        count = 0;
        running = 1;
        lasttimestamp = System.currentTimeMillis();
        debug = new String("");
        httpgetdata = new String("");

        // Save the parrent thread
        themommy = temp;

        // Set the state
        state = new String("Starting");

        // Save the name
        cellname = new String(tempname);

        // Save the password
        cellpassword = new String(temppassword);
        
        // Save the count
        count = tempcount;

        // Save the URL
        url = tempurl;
    }
    // *************************************************************************


    // *************************************************************************
    public void run() {

        // Should we run?
        if (running == 1) {

            // Increment out counter + timestamp
            state = new String("Starting");
            lasttimestamp = System.currentTimeMillis();

            // Name and Password
            state = "Name + Pwd";
            httpgetdata = "cellname=" + cellname;
            httpgetdata = httpgetdata + "&cellpassword=" + cellpassword;

            // Count
            state = "Count";
            httpgetdata = httpgetdata + "&count=" + Integer.toString(count);
            debug = Integer.toString(count);
            if (count == 1) {
                debug = debug + ",STARTING";
            }
            
            // Timestamp
            state = "Timestamp";
            httpgetdata = httpgetdata + "&timestamp=" + Long.toString(lasttimestamp);

            // Signal strength
            state = "Signal";
            themommy.setLastSignal((int)StatusManager.getStatus(StatusManager.SIGNAL_STRENGTH));
            httpgetdata = httpgetdata + "&signal=" + Integer.toString((int)StatusManager.getStatus(StatusManager.SIGNAL_STRENGTH));

            // Battery
            state = "Battery";
            themommy.setLastBattery((int)StatusManager.getStatus(StatusManager.BATTERY_LEVEL));
            httpgetdata = httpgetdata + "&battery=" + Integer.toString((int)StatusManager.getStatus(StatusManager.BATTERY_LEVEL));

            // GPS Collection
            try {
                state = "GPS";
                gpscriteria = new Criteria();
                gpscriteria.setHorizontalAccuracy(1000);
                gpslocationprovider = LocationProvider.getInstance(gpscriteria);
                gpslocation = gpslocationprovider.getLocation(30);
                gpscoordinates = gpslocation.getQualifiedCoordinates();

                if(gpscoordinates != null ) {
                    if ((gpslocation.getLocationMethod() & gpslocation.MTE_CELLID) == gpslocation.MTE_CELLID) {
                        httpgetdata = httpgetdata + "&locationtype=CELL";
                        httpgetdata = httpgetdata + "&latitude=" + Double.toString(gpscoordinates.getLatitude());
                        httpgetdata = httpgetdata + "&longitude=" + Double.toString(gpscoordinates.getLongitude());
                        httpgetdata = httpgetdata + "&positionaccuracy=-1";
                        httpgetdata = httpgetdata + "&altitude=-1";
                        httpgetdata = httpgetdata + "&altitudeaccuracy=-1";
                        httpgetdata = httpgetdata + "&speed=-1";
                        httpgetdata = httpgetdata + "&heading=-1";
                        themommy.setLastAccuracy(-1);

                    // Obtained via GPS Sattelite
                    } else if ((gpslocation.getLocationMethod() & gpslocation.MTE_SATELLITE) == gpslocation.MTE_SATELLITE) {
                        httpgetdata = httpgetdata + "&locationtype=GPS";
                        httpgetdata = httpgetdata + "&latitude=" + Double.toString(gpscoordinates.getLatitude());
                        httpgetdata = httpgetdata + "&longitude=" + Double.toString(gpscoordinates.getLongitude());
                        httpgetdata = httpgetdata + "&positionaccuracy=" + Long.toString((long)gpscoordinates.getHorizontalAccuracy());
                        httpgetdata = httpgetdata + "&altitude=" + Long.toString((long)gpscoordinates.getAltitude());
                        httpgetdata = httpgetdata + "&altitudeaccuracy=" + Long.toString((long)gpscoordinates.getVerticalAccuracy());
                        httpgetdata = httpgetdata + "&speed=" + Long.toString((long)gpslocation.getSpeed());
                        httpgetdata = httpgetdata + "&heading=" + Long.toString((long)gpslocation.getCourse());
                        themommy.setLastAccuracy((int)gpscoordinates.getHorizontalAccuracy());

                    // We don't know how we got it
                    } else {
                        httpgetdata = httpgetdata + "&locationtype=UNKNOWN";
                        httpgetdata = httpgetdata + "&latitude=" + Double.toString(gpscoordinates.getLatitude());
                        httpgetdata = httpgetdata + "&longitude=" + Double.toString(gpscoordinates.getLongitude());
                        httpgetdata = httpgetdata + "&positionaccuracy=" + Long.toString((long)gpscoordinates.getHorizontalAccuracy());
                        httpgetdata = httpgetdata + "&altitude=" + Long.toString((long)gpscoordinates.getAltitude());
                        httpgetdata = httpgetdata + "&altitudeaccuracy=" + Long.toString((long)gpscoordinates.getVerticalAccuracy());
                        httpgetdata = httpgetdata + "&speed=" + Long.toString((long)gpslocation.getSpeed());
                        httpgetdata = httpgetdata + "&heading=" + Long.toString((long)gpslocation.getCourse());
                        themommy.setLastAccuracy((int)gpscoordinates.getHorizontalAccuracy());
                    }
                }
            } catch (Exception e) {
                debug = debug + ",GPSFAIL";
            }

            // Throw the debug data on the end
            httpgetdata = httpgetdata + "&debug=" + debug;

            // Send HTTP Request
            state = "HTTP_Request";
            try {
                httpconn = null;
                httpconn = (HttpConnection)Connector.open(url + httpgetdata);
                httpconn.setRequestMethod("GET");
                if (httpconn.getResponseCode() == HttpConnection.HTTP_OK) {
                    state = "HTTPResp";
                }
                httpconn.close();
             } catch (Exception e) {
             }
        }

        state = "Done";
        running = 0;

    }
    // *************************************************************************


    // *************************************************************************
    public void killme() {
        synchronized (this) {
            running = 0;

            try {
                if (httpconn != null)
                    httpconn.close();
                httpconn = null;
            } catch (Exception e) {

            }
        }
    }
    // *************************************************************************


    // *************************************************************************
    public int getRunning() {
        synchronized (this) {
            return running;
        }
    }
    // *************************************************************************


    // *************************************************************************
    public String getState() {
        synchronized (this) {
            return state;
        }
    }
    // *************************************************************************


}